package com.sun.org.apache.bcel.internal.util;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;

public final class ByteSequence extends DataInputStream
{
    private final ByteSequence.ByteArrayStream byteStream;
    
    public ByteSequence(byte[] bytes) {
        super(new ByteArrayStream(bytes));
        this.byteStream = (ByteSequence.ByteArrayStream)this.in;
    }
    
    public final int getIndex() {
        return this.byteStream.getPosition();
    }
    
    final void unreadByte() {
        this.byteStream.unreadByte();
    }
    
    private static final class ByteArrayStream extends ByteArrayInputStream
    {
        ByteArrayStream(byte[] bytes) {
            super(bytes);
        }
        
        final int getPosition() {
            return this.pos;
        }
        
        final void unreadByte() {
            if (this.pos > 0) {
                --this.pos;
            }
        }
    }
}
